
# (C) 2001-2018 Altera Corporation. All rights reserved.
# Your use of Altera Corporation's design tools, logic functions and 
# other software and tools, and its AMPP partner logic functions, and 
# any output files any of the foregoing (including device programming 
# or simulation files), and any associated documentation or information 
# are expressly subject to the terms and conditions of the Altera 
# Program License Subscription Agreement, Altera MegaCore Function 
# License Agreement, or other applicable license agreement, including, 
# without limitation, that your use is for the sole purpose of 
# programming logic devices manufactured by Altera and sold by Altera 
# or its authorized distributors. Please refer to the applicable 
# agreement for further details.

# ACDS 16.0 211 linux 2018.11.22.14:24:11

# ----------------------------------------
# ncsim - auto-generated simulation script

# ----------------------------------------
# This script provides commands to simulate the following IP detected in
# your Quartus project:
#     arria10_pcie_hip
# 
# Altera recommends that you source this Quartus-generated IP simulation
# script from your own customized top-level script, and avoid editing this
# generated script.
# 
# To write a top-level shell script that compiles Altera simulation libraries
# and the Quartus-generated IP in your project, along with your design and
# testbench files, copy the text from the TOP-LEVEL TEMPLATE section below
# into a new file, e.g. named "ncsim.sh", and modify text as directed.
# 
# You can also modify the simulation flow to suit your needs. Set the
# following variables to 1 to disable their corresponding processes:
# - SKIP_FILE_COPY: skip copying ROM/RAM initialization files
# - SKIP_DEV_COM: skip compiling the Quartus EDA simulation library
# - SKIP_COM: skip compiling Quartus-generated IP simulation files
# - SKIP_ELAB and SKIP_SIM: skip elaboration and simulation
# 
# ----------------------------------------
# # TOP-LEVEL TEMPLATE - BEGIN
# #
# # QSYS_SIMDIR is used in the Quartus-generated IP simulation script to
# # construct paths to the files required to simulate the IP in your Quartus
# # project. By default, the IP script assumes that you are launching the
# # simulator from the IP script location. If launching from another
# # location, set QSYS_SIMDIR to the output directory you specified when you
# # generated the IP script, relative to the directory from which you launch
# # the simulator. In this case, you must also copy the generated files
# # "cds.lib" and "hdl.var" - plus the directory "cds_libs" if generated - 
# # into the location from which you launch the simulator, or incorporate
# # into any existing library setup.
# #
# # Run Quartus-generated IP simulation script once to compile Quartus EDA
# # simulation libraries and Quartus-generated IP simulation files, and copy
# # any ROM/RAM initialization files to the simulation directory.
# # - If necessary, specify USER_DEFINED_COMPILE_OPTIONS.
# #
# source <script generation output directory>/cadence/ncsim_setup.sh \
# SKIP_ELAB=1 \
# SKIP_SIM=1 \
# USER_DEFINED_COMPILE_OPTIONS=<compilation options for your design> \
# QSYS_SIMDIR=<script generation output directory>
# #
# # Compile all design files and testbench files, including the top level.
# # (These are all the files required for simulation other than the files
# # compiled by the IP script)
# #
# ncvlog <compilation options> <design and testbench files>
# #
# # TOP_LEVEL_NAME is used in this script to set the top-level simulation or
# # testbench module/entity name.
# #
# # Run the IP script again to elaborate and simulate the top level:
# # - Specify TOP_LEVEL_NAME and USER_DEFINED_ELAB_OPTIONS.
# # - Override the default USER_DEFINED_SIM_OPTIONS. For example, to run
# #   until $finish(), set to an empty string: USER_DEFINED_SIM_OPTIONS="".
# #
# source <script generation output directory>/cadence/ncsim_setup.sh \
# SKIP_FILE_COPY=1 \
# SKIP_DEV_COM=1 \
# SKIP_COM=1 \
# TOP_LEVEL_NAME=<simulation top> \
# USER_DEFINED_ELAB_OPTIONS=<elaboration options for your design> \
# USER_DEFINED_SIM_OPTIONS=<simulation options for your design>
# #
# # TOP-LEVEL TEMPLATE - END
# ----------------------------------------
# 
# IP SIMULATION SCRIPT
# ----------------------------------------
# If arria10_pcie_hip is one of several IP cores in your
# Quartus project, you can generate a simulation script
# suitable for inclusion in your top-level simulation
# script by running the following command line:
# 
# ip-setup-simulation --quartus-project=<quartus project>
# 
# ip-setup-simulation will discover the Altera IP
# within the Quartus project, and generate a unified
# script which supports all the Altera IP within the design.
# ----------------------------------------
# ACDS 16.0 211 linux 2018.11.22.14:24:11
# ----------------------------------------
# initialize variables
TOP_LEVEL_NAME="arria10_pcie_hip"
QSYS_SIMDIR="./../"
QUARTUS_INSTALL_DIR="/home/alex/workspace/optional/quartus16/quartus/"
SKIP_FILE_COPY=0
SKIP_DEV_COM=0
SKIP_COM=0
SKIP_ELAB=0
SKIP_SIM=0
USER_DEFINED_ELAB_OPTIONS=""
USER_DEFINED_SIM_OPTIONS="-input \"@run 100; exit\""

# ----------------------------------------
# overwrite variables - DO NOT MODIFY!
# This block evaluates each command line argument, typically used for 
# overwriting variables. An example usage:
#   sh <simulator>_setup.sh SKIP_SIM=1
for expression in "$@"; do
  eval $expression
  if [ $? -ne 0 ]; then
    echo "Error: This command line argument, \"$expression\", is/has an invalid expression." >&2
    exit $?
  fi
done

# ----------------------------------------
# initialize simulation properties - DO NOT MODIFY!
ELAB_OPTIONS=""
SIM_OPTIONS=""
if [[ `ncsim -version` != *"ncsim(64)"* ]]; then
  :
else
  :
fi

# ----------------------------------------
# create compilation libraries
mkdir -p ./libraries/work/
mkdir -p ./libraries/altera_common_sv_packages/
mkdir -p ./libraries/arria10_pcie_hip_altera_xcvr_fpll_a10_160/
mkdir -p ./libraries/arria10_pcie_hip_altera_xcvr_native_a10_160/
mkdir -p ./libraries/arria10_pcie_hip_altera_pcie_a10_hip_160/
mkdir -p ./libraries/altera_ver/
mkdir -p ./libraries/lpm_ver/
mkdir -p ./libraries/sgate_ver/
mkdir -p ./libraries/altera_mf_ver/
mkdir -p ./libraries/altera_lnsim_ver/
mkdir -p ./libraries/twentynm_ver/
mkdir -p ./libraries/twentynm_hssi_ver/
mkdir -p ./libraries/twentynm_hip_ver/

# ----------------------------------------
# copy RAM/ROM files to simulation directory

# ----------------------------------------
# compile device library files
if [ $SKIP_DEV_COM -eq 0 ]; then
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_primitives.v"                  -work altera_ver       
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/220model.v"                           -work lpm_ver          
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/sgate.v"                              -work sgate_ver        
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_mf.v"                          -work altera_mf_ver    
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS "$QUARTUS_INSTALL_DIR/eda/sim_lib/altera_lnsim.sv"                      -work altera_lnsim_ver 
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/twentynm_atoms.v"                     -work twentynm_ver     
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/cadence/twentynm_atoms_ncrypt.v"      -work twentynm_ver     
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/cadence/twentynm_hssi_atoms_ncrypt.v" -work twentynm_hssi_ver
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/twentynm_hssi_atoms.v"                -work twentynm_hssi_ver
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/cadence/twentynm_hip_atoms_ncrypt.v"  -work twentynm_hip_ver 
  ncvlog $USER_DEFINED_COMPILE_OPTIONS     "$QUARTUS_INSTALL_DIR/eda/sim_lib/twentynm_hip_atoms.v"                 -work twentynm_hip_ver 
fi

# ----------------------------------------
# compile design files in correct order
if [ $SKIP_COM -eq 0 ]; then
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/altera_xcvr_native_a10_functions_h.sv"                  -work altera_common_sv_packages                   -cdslib ./cds_libs/altera_common_sv_packages.cds.lib                  
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_fpll_a10_160/sim/twentynm_xcvr_avmm.sv"                                    -work arria10_pcie_hip_altera_xcvr_fpll_a10_160   -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_fpll_a10_160.cds.lib  
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_fpll_a10_160/sim/alt_xcvr_resync.sv"                                       -work arria10_pcie_hip_altera_xcvr_fpll_a10_160   -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_fpll_a10_160.cds.lib  
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_fpll_a10_160/sim/altera_xcvr_fpll_a10.sv"                                  -work arria10_pcie_hip_altera_xcvr_fpll_a10_160   -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_fpll_a10_160.cds.lib  
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_fpll_a10_160/sim/a10_avmm_h.sv"                                            -work arria10_pcie_hip_altera_xcvr_fpll_a10_160   -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_fpll_a10_160.cds.lib  
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_fpll_a10_160/sim/alt_xcvr_native_avmm_nf.sv"                               -work arria10_pcie_hip_altera_xcvr_fpll_a10_160   -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_fpll_a10_160.cds.lib  
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_fpll_a10_160/sim/alt_xcvr_pll_embedded_debug.sv"                           -work arria10_pcie_hip_altera_xcvr_fpll_a10_160   -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_fpll_a10_160.cds.lib  
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_fpll_a10_160/sim/alt_xcvr_pll_avmm_csr.sv"                                 -work arria10_pcie_hip_altera_xcvr_fpll_a10_160   -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_fpll_a10_160.cds.lib  
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/alt_xcvr_resync.sv"                                     -work arria10_pcie_hip_altera_xcvr_native_a10_160 -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_native_a10_160.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/alt_xcvr_arbiter.sv"                                    -work arria10_pcie_hip_altera_xcvr_native_a10_160 -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_native_a10_160.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/twentynm_pcs.sv"                                        -work arria10_pcie_hip_altera_xcvr_native_a10_160 -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_native_a10_160.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/twentynm_pma.sv"                                        -work arria10_pcie_hip_altera_xcvr_native_a10_160 -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_native_a10_160.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/twentynm_xcvr_avmm.sv"                                  -work arria10_pcie_hip_altera_xcvr_native_a10_160 -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_native_a10_160.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/twentynm_xcvr_native.sv"                                -work arria10_pcie_hip_altera_xcvr_native_a10_160 -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_native_a10_160.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/a10_avmm_h.sv"                                          -work arria10_pcie_hip_altera_xcvr_native_a10_160 -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_native_a10_160.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/alt_xcvr_native_pipe_retry.sv"                          -work arria10_pcie_hip_altera_xcvr_native_a10_160 -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_native_a10_160.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/alt_xcvr_native_avmm_csr.sv"                            -work arria10_pcie_hip_altera_xcvr_native_a10_160 -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_native_a10_160.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/alt_xcvr_native_prbs_accum.sv"                          -work arria10_pcie_hip_altera_xcvr_native_a10_160 -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_native_a10_160.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/alt_xcvr_native_odi_accel.sv"                           -work arria10_pcie_hip_altera_xcvr_native_a10_160 -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_native_a10_160.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/alt_xcvr_native_rcfg_arb.sv"                            -work arria10_pcie_hip_altera_xcvr_native_a10_160 -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_native_a10_160.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/arria10_pcie_hip_altera_xcvr_native_a10_160_hl7ikni.sv" -work arria10_pcie_hip_altera_xcvr_native_a10_160 -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_native_a10_160.cds.lib
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_xcvr_native_a10_160/sim/alt_xcvr_native_rcfg_opt_logic_hl7ikni.sv"              -work arria10_pcie_hip_altera_xcvr_native_a10_160 -cdslib ./cds_libs/arria10_pcie_hip_altera_xcvr_native_a10_160.cds.lib
  ncvlog -compcnfg $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/fpll_g1g2xn.v"                                             -work arria10_pcie_hip_altera_pcie_a10_hip_160                                                                          
  ncvlog -compcnfg $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/phy_g1x4.v"                                                -work arria10_pcie_hip_altera_pcie_a10_hip_160                                                                          
  ncvlog $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/arria10_pcie_hip_altera_pcie_a10_hip_160_zhavyyy.v"        -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altpcie_a10_hip_pipen1b.v"                                 -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altpcie_sc_bitsync.v"                                      -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altpcie_reset_delay_sync.v"                                -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altpcie_rs_a10_hip.v"                                      -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altpcie_a10_hip_pllnphy.v"                                 -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/skp_det_g3.v"                                              -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altera_xcvr_functions.sv"                                  -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altpcie_monitor_a10_dlhip_sim.sv"                          -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altpcie_tlp_inspector_a10.v"                               -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altpcie_tlp_inspector_cseb_a10.sv"                         -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog -sv $USER_DEFINED_COMPILE_OPTIONS       "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altpcie_tlp_inspector_monitor_a10.sv"                      -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altpcie_tlp_inspector_trigger_a10.v"                       -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altpcie_tlp_inspector_pcsig_drive_a10.v"                   -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altpcie_a10_gbfifo.v"                                      -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altpcie_scfifo_a10.v"                                      -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog $USER_DEFINED_COMPILE_OPTIONS           "$QSYS_SIMDIR/../altera_pcie_a10_hip_160/sim/altpcie_a10_scfifo_ext.v"                                  -work arria10_pcie_hip_altera_pcie_a10_hip_160    -cdslib ./cds_libs/arria10_pcie_hip_altera_pcie_a10_hip_160.cds.lib   
  ncvlog -compcnfg $USER_DEFINED_COMPILE_OPTIONS "$QSYS_SIMDIR/arria10_pcie_hip.v"                                                                                                                                                                                               
fi

# ----------------------------------------
# elaborate top level design
if [ $SKIP_ELAB -eq 0 ]; then
  ncelab -access +w+r+c -namemap_mixgen $ELAB_OPTIONS $USER_DEFINED_ELAB_OPTIONS $TOP_LEVEL_NAME
fi

# ----------------------------------------
# simulate
if [ $SKIP_SIM -eq 0 ]; then
  eval ncsim -licqueue $SIM_OPTIONS $USER_DEFINED_SIM_OPTIONS $TOP_LEVEL_NAME
fi
